## NAME

curl_share_setopt - Set options for a shared object

## SYNOPSIS

#include <curl/curl.h>

CURLSHcode curl_share_setopt(CURLSH *share, CURLSHoption option, parameter);

## DESCRIPTION

Set the option to parameter for the given share.

## OPTIONS

CURLSHOPT_LOCKFUNC

The parameter must be a pointer to a function matching the following prototype:

void lock_function(CURL *handle, curl_lock_data data, curl_lock_access access, void *userptr);

data defines what data libcurl wants to lock, and you must make sure that only one lock is given at any time for each kind of data.

access defines what access type libcurl wants, shared or single.

userptr is the pointer you set with CURLSHOPT_USERDATA.

CURLSHOPT_UNLOCKFUNC

The parameter must be a pointer to a function matching the following prototype:

void unlock_function(CURL *handle, curl_lock_data data, void *userptr);

data defines what data libcurl wants to unlock, and you must make sure that only one lick is given at any time for each kind of data.

userptr is the pointer you set with CURLSHOPT_USERDATA.

CURLSHOPT_SHARE

The parameter specifies a type of data that should be shared. This may be set to one of the values described below.

CURL_LOCK_DATA_COOKIE

Cookie data will be shared across the easy handles using this shared object.

CURL_LOCK_DATA_DNS

Cached DNS hosts will be shared across the easy handles using this shared object.

CURLSHOPT_UNSHARE

This option does the opposite of CURLSHOPT_SHARE. It specifies that the specified parameter will no longer be shared. Valid values are the same as those for CURLSHOPT_SHARE.

CURLSHOPT_USERDATA

The parameter allows you to specify a pointer to data that will passed to the lock_function and unlock_function each time it is called.

## RETURN VALUE

CURLSHE_OK (zero) means that the option was set properly, non-zero means an error occurred as <curl/curl.h> defines. See the libcurl-errors.3 man page for the full list with descriptions.

## SEE ALSO

curl_share_cleanup (3) curl_share_init (3)

This HTML page was made with roffit.